package com.shcd.ghjg.service;


import com.shcd.ghjg.emtity.MyThread;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.Objects;
import java.util.Queue;
import java.util.concurrent.*;

@Service
@Slf4j
public class TcpService {
    @Value("${serviceAddress}")
    private String serviceAddress;
    @Value("${servicePort}")
    private String servicePort;
    @Value("${servicePassword}")
    private String servicePassword;

    private static Queue<byte[]> queue = new ConcurrentLinkedQueue<>();

    private ServerSocket serverSocket = new ServerSocket(8100);

    public TcpService() throws IOException {
    }

    @PostConstruct
    public void acceptTcp() throws IOException {
        log.info("客户端启动，等待连接");
        Socket socket = new Socket(InetAddress.getByName(serviceAddress), Integer.parseInt(servicePort));
        log.info("链接成功");
        socket.getOutputStream().write(servicePassword.getBytes());
        log.info("发送密钥");
        InputStream inputStream = socket.getInputStream();
        int len;
        byte[] bytes = new byte[1024];
        Socket accept = serverSocket.accept();
        ThreadFactory factory = Thread::new;
//        ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 4, 5, TimeUnit.SECONDS, new LinkedBlockingDeque<>(10), factory, new ThreadPoolExecutor.AbortPolicy());
        ExecutorService executor = Executors.newFixedThreadPool(2);
        while ((len = inputStream.read(bytes)) != -1) {
            byte[] bytes1 = new String(bytes, 0, len).getBytes();
            queue.add(bytes1);
            if (accept.isConnected()) {
                try {
                    Socket finalAccept = accept;
                    executor.execute(() ->{
                        try {
                            OutputStream outputStream = finalAccept.getOutputStream();
                            byte[] poll = queue.poll();
                            if ( poll != null){
                                outputStream.write(poll);
                                outputStream.flush();
                                log.warn("转发内容"  + new String(poll));
                            }
                        } catch (IOException e) {
                            executor.shutdown();
                            throw new RuntimeException(e);
                        }
                    });
//                    log.warn("接收内容" + new String(bytes1));
                } catch (Exception e) {
                    accept.close();
                    e.printStackTrace();
                }
            } else {
                log.info("重启");
                accept = serverSocket.accept();
            }
        }
    }
}
